diff -Naur a/CHROMIUM_VERSION b/CHROMIUM_VERSION
--- a/CHROMIUM_VERSION	1970-01-01 01:00:00.000000000 +0100
+++ b/CHROMIUM_VERSION	2021-11-20 03:33:14.168428455 +0000
@@ -0,0 +1,2 @@
+Based on Chromium version:                                      87.0.4280.144
+Patched with security patches up to Chromium version:           94.0.4606.61
diff -Naur a/CVE-fixes b/CVE-fixes
--- a/CVE-fixes	2021-08-25 16:32:13.000000000 +0100
+++ b/CVE-fixes	2021-11-20 04:05:13.820919579 +0000
@@ -1,12 +1,35 @@
 Cumulative CVE fixes since 5.15.2 (the last non paid-for release)
 
-Fixed in this 5.15.6 snapshot:
+Fixed in this 5.15.7 patch:
 
-CVE-2021-30604: Use after free in ANGLE				 Not yet public
-CVE-2021-30603: Race in WebAudio				 Not yet public
-CVE-2021-30602: Use after free in WebRTC			 Not yet public
-CVE-2021-30599: Type Confusion in V8				 Not yet public
-CVE-2021-30598: Type Confusion in V8				 Not yet public
+CVE-2021-37980 : Inappropriate implementation in Sandbox              High
+CVE-2021-37979 : Heap buffer overflow in WebRTC                       High
+CVE-2021-37978 : Heap buffer overflow in Blink                        High
+CVE-2021-37975 : Use after free in V8                                 High
+CVE-2021-37973 : Use after free in Portals                            Critical
+CVE-2021-37972 : Out of bounds read in libjpeg-turbo                  High
+CVE-2021-37971 : Incorrect security UI in Web Browser UI.             Medium
+CVE-2021-37968 : Inappropriate implementation in Background Fetch API Medium
+CVE-2021-37967 : Inappropriate implementation in Background Fetch API Medium
+CVE-2021-37962 : Use after free in Performance Manager                High
+CVE-2021-30633: Use after free in Indexed DB API                      Critical
+CVE-2021-30630: Inappropriate implementation in Blink                 Medium
+CVE-2021-30629: Use after free in Permissions                         High
+CVE-2021-30628: Stack buffer overflow in ANGLE                        High
+CVE-2021-30627: Type Confusion in Blink layout                        High
+CVE-2021-30626: Out of bounds memory access in ANGLE                  High
+CVE-2021-30625: Use after free in Selection API                       High
+CVE-2021-30618: Inappropriate implementation in DevTools              High
+CVE-2021-30616: Use after free in Media.                              High
+CVE-2021-30613: Use after free in Base internals                      High
+
+Previously fixed in the 5.15.6 snapshot:
+
+CVE-2021-30604: Use after free in ANGLE				 High
+CVE-2021-30603: Race in WebAudio				 High
+CVE-2021-30602: Use after free in WebRTC			 High
+CVE-2021-30599: Type Confusion in V8				 High
+CVE-2021-30598: Type Confusion in V8				 High
 CVE-2021-30588: Type Confusion in V8				 High
 CVE-2021-30587: Inappropriate implementation in Compositing	 Medium
 CVE-2021-30585: Use after free in sensor handling		 High
@@ -42,7 +65,7 @@
 CVE-2021-30510: Race in Aura
 CVE-2021-30508: Heap buffer overflow in Media Feeds
 
-Previously fixed in qtwebengien-20210401-upstream_fixes-1.patch
+Previously fixed in qtwebengine-20210401-upstream_fixes-1.patch
 
 CVE-2021-21233-Heap-buffer-overflow-in-ANGL.patch
 CVE-2021-21231-Insufficient-data-validation.patch
diff -Naur a/examples/webenginewidgets/markdowneditor/mainwindow.cpp b/examples/webenginewidgets/markdowneditor/mainwindow.cpp
--- a/examples/webenginewidgets/markdowneditor/mainwindow.cpp	2021-08-24 13:35:32.000000000 +0100
+++ b/examples/webenginewidgets/markdowneditor/mainwindow.cpp	2021-11-20 03:27:27.961255186 +0000
@@ -170,7 +170,7 @@
 void MainWindow::onFileSaveAs()
 {
     QString path = QFileDialog::getSaveFileName(this,
-        tr("Save MarkDown File"), "", tr("MarkDown File (*.md, *.markdown)"));
+        tr("Save MarkDown File"), "", tr("MarkDown File (*.md *.markdown)"));
     if (path.isEmpty())
         return;
     m_filePath = path;
diff -Naur a/GIT-VERSIONS b/GIT-VERSIONS
--- a/GIT-VERSIONS	2021-08-25 16:32:49.000000000 +0100
+++ b/GIT-VERSIONS	2021-11-20 04:10:05.796278465 +0000
@@ -1,44 +1,33 @@
-qtwebengine-5.15.6 is at
+This patch updates BLFS's qtwebengien-5.15.6 to 5.15.7.
+It is taken from the 5.15 branch after the 5.15.7 changes were merged back.
 
-commit 2acbba86362ac3a1c2d8c20390dc263875f8f09c (HEAD -> 5.15.6, origin/5.15.6)
-Author: Michael Brüning <michael.bruning@qt.io>
-Date:   Tue Aug 24 14:21:04 2021 +0200
+qtwebengien is at
+
+commit 604f42c37b36a4674f953665f84872e4d83e0316 (HEAD -> 5.15)
+Author: Allan Sandfeld Jensen <allan.jensen@qt.io>
+Date:   Tue Oct 19 14:46:32 2021 +0200
 
     Update Chromium
     
-    Submodule src/3rdparty c8087cb6..9f71911e:
-    
-      > [Backport] CVE-2021-30560: Use after free in Blink XSLT
-    
-    Task-number: QTBUG-94103
-    Change-Id: I3e43653b6b3370d71b09b52a781a3b1d6c82293e
-    Reviewed-by: Allan Sandfeld Jensen <allan.jensen@qt.io>
+    Submodule src/3rdparty 9f71911e3..8c0a9b445:
+      > Revert "[Backport] Security bug 1239116"
+     [...]
 
 
 src/3rdparty/chromium is at
 
-commit 9f71911e38c041cedc5291c5e772b7d03ce8b8c8 (HEAD -> 87-based, origin/87-based)
-Author: Roger Zanoni <rzanoni@google.com>
-Date:   Wed Jul 28 09:34:36 2021 +0000
+commit 8c0a9b4459f5200a24ab9e687a3fb32e975382e5 (HEAD -> 87-based)
+Author: Allan Sandfeld Jensen <allan.jensen@qt.io>
+Date:   Tue Oct 19 17:35:51 2021 +0000
 
-    [Backport] CVE-2021-30560: Use after free in Blink XSLT
+    Revert "[Backport] Security bug 1239116"
     
-    Cherry-pick of patch originally reviewed on
-    https://chromium-review.googlesource.com/c/chromium/src/+/3042731:
-    Fix use-after-free with XSLT strip-space
+    This reverts commit adcb7c9d94a507286e02c6c2005498011eb5a554.
     
-    (cherry picked from commit 79fc7bcbc940a66f4edfd2c49a5e63106074836a)
-    
-    Fixed: 1219209
-    Change-Id: I3baab9d1b419407d964a80f10c6ca05e0294554f
-    Commit-Queue: Joey Arhar <jarhar@chromium.org>
-    Cr-Original-Commit-Position: refs/heads/master@{#892861}
-    Reviewed-by: Jana Grill <janagrill@google.com>
-    Owners-Override: Jana Grill <janagrill@google.com>
-    Commit-Queue: Roger Felipe Zanoni da Silva <rzanoni@google.com>
-    Cr-Commit-Position: refs/branch-heads/4430@{#1545}
-    Cr-Branched-From: e5ce7dc4f7518237b3d9bb93cccca35d25216cbe-refs/heads/master@{#857950}
-    Reviewed-by: Allan Sandfeld Jensen <allan.jensen@qt.io>
+    Reason for revert: Doesn't compile on its own
+
 
 For details of all the backported CVE fixes since qtwebengine-5.15.2 see CVE-fixes.
 
+See CHROMIUM_VERSION for details of chromium patches backported
+
diff -Naur a/.qmake.conf b/.qmake.conf
--- a/.qmake.conf	2021-08-24 13:35:32.000000000 +0100
+++ b/.qmake.conf	2021-11-20 03:26:34.578137143 +0000
@@ -5,4 +5,4 @@
 load(qt_build_config)
 CONFIG += warning_clean
 
-MODULE_VERSION = 5.15.6
+MODULE_VERSION = 5.15.7
diff -Naur a/src/3rdparty/chromium/AUTHORS b/src/3rdparty/chromium/AUTHORS
--- a/src/3rdparty/chromium/AUTHORS	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/AUTHORS	2021-11-20 03:43:06.618124013 +0000
@@ -33,6 +33,7 @@
 Adenilson Cavalcanti <a.cavalcanti@samsung.com>
 Aditya Bhargava <heuristicist@gmail.com>
 Adrian Belgun <adrian.belgun@intel.com>
+Adrian Ratiu <adrian.ratiu@collabora.corp-partner.google.com>
 Ahmet Emir Ercin <ahmetemiremir@gmail.com>
 Ajay Berwal <a.berwal@samsung.com>
 Ajay Berwal <ajay.berwal@samsung.com>
diff -Naur a/src/3rdparty/chromium/base/threading/scoped_blocking_call_internal.cc b/src/3rdparty/chromium/base/threading/scoped_blocking_call_internal.cc
--- a/src/3rdparty/chromium/base/threading/scoped_blocking_call_internal.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/base/threading/scoped_blocking_call_internal.cc	2021-11-20 03:35:18.840494500 +0000
@@ -56,7 +56,20 @@
 
 IOJankMonitoringWindow::ScopedMonitoredCall::ScopedMonitoredCall()
     : call_start_(TimeTicks::Now()),
-      assigned_jank_window_(MonitorNextJankWindowIfNecessary(call_start_)) {}
+      assigned_jank_window_(MonitorNextJankWindowIfNecessary(call_start_)) {
+  if (assigned_jank_window_) {
+    // TimeTicks using a monotonic clock and MonitorNextJankWindowIfNecessary
+    // synchronizing via a lock to return |assigned_jank_window_| was initially
+    // believed to guarantee that |call_start_| is either equal or beyond
+    // |assigned_jank_window_->start_time_|. Violating this assumption can
+    // result in negative indexing and OOB-writes in AddJank().
+    // We now know this assumption can be violated. This condition hotfixes
+    // the issue by discarding ScopedMonitoredCalls where it occurs.
+    // TODO(crbug.com/1209622): Implement a proper fix.
+    if (call_start_ < assigned_jank_window_->start_time_)
+      assigned_jank_window_.reset();
+  }
+}
 
 IOJankMonitoringWindow::ScopedMonitoredCall::~ScopedMonitoredCall() {
   if (assigned_jank_window_) {
@@ -187,6 +200,11 @@
 
 void IOJankMonitoringWindow::OnBlockingCallCompleted(TimeTicks call_start,
                                                      TimeTicks call_end) {
+  // Confirm we never hit a case of TimeTicks going backwards on the same thread
+  // nor of TimeTicks rolling over the int64_t boundary (which would break
+  // comparison operators).
+  DCHECK_LE(call_start, call_end);
+
   if (call_end - call_start < kIOJankInterval)
     return;
 
@@ -210,6 +228,9 @@
 
 void IOJankMonitoringWindow::AddJank(int local_jank_start_index,
                                      int num_janky_intervals) {
+  DCHECK_GE(local_jank_start_index, 0);
+  DCHECK_LT(local_jank_start_index, kNumIntervals);
+
   // Increment jank counts for intervals in this window. If
   // |num_janky_intervals| lands beyond kNumIntervals, the additional intervals
   // will be reported to |next_|.
diff -Naur a/src/3rdparty/chromium/base/threading/scoped_blocking_call_internal.h b/src/3rdparty/chromium/base/threading/scoped_blocking_call_internal.h
--- a/src/3rdparty/chromium/base/threading/scoped_blocking_call_internal.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/base/threading/scoped_blocking_call_internal.h	2021-11-20 03:35:18.840494500 +0000
@@ -93,6 +93,12 @@
   static constexpr TimeDelta kTimeDiscrepancyTimeout = TimeDelta::FromMicroseconds(10 * 1000 * 1000 * 1000LL);
   static constexpr int kNumIntervals = kMonitoringWindow / kIOJankInterval;
 
+  // kIOJankIntervals must integrally fill kMonitoringWindow
+  static_assert((kMonitoringWindow % kIOJankInterval).is_zero(), "");
+
+  // Cancelation is simple because it can only affect the current window.
+  static_assert(kTimeDiscrepancyTimeout < kMonitoringWindow, "");
+
  private:
   friend class base::RefCountedThreadSafe<IOJankMonitoringWindow>;
   friend void base::EnableIOJankMonitoringForProcess(IOJankReportingCallback);
diff -Naur a/src/3rdparty/chromium/build/config/win/BUILD.gn b/src/3rdparty/chromium/build/config/win/BUILD.gn
--- a/src/3rdparty/chromium/build/config/win/BUILD.gn	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/build/config/win/BUILD.gn	2021-11-20 03:41:21.545790330 +0000
@@ -42,6 +42,8 @@
   #  and with this switch, clang emits it like this:
   #    foo/bar.cc:12:34: error: something went wrong
   use_clang_diagnostics_format = false
+
+  qt_uses_static_runtime = false
 }
 
 # This is included by reference in the //build/config/compiler config that
@@ -469,7 +471,12 @@
     # Component mode: dynamic CRT. Since the library is shared, it requires
     # exceptions or will give errors about things not matching, so keep
     # exceptions on.
-    configs = [ ":dynamic_crt" ]
+    if (qt_uses_static_runtime) {
+       # we always do is_shared, however qt can link final lib as static, with static runtime
+       configs = [ ":static_crt" ]
+    } else {
+       configs = [ ":dynamic_crt" ]
+    }
   } else {
     if (current_os == "winuwp") {
       # https://blogs.msdn.microsoft.com/vcblog/2014/06/10/the-great-c-runtime-crt-refactoring/
diff -Naur a/src/3rdparty/chromium/chrome/browser/ui/webui/discards/discards_ui.h b/src/3rdparty/chromium/chrome/browser/ui/webui/discards/discards_ui.h
--- a/src/3rdparty/chromium/chrome/browser/ui/webui/discards/discards_ui.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/chrome/browser/ui/webui/discards/discards_ui.h	2021-11-20 03:39:18.065771968 +0000
@@ -37,7 +37,6 @@
 
  private:
   std::unique_ptr<discards::mojom::DetailsProvider> ui_handler_;
-  std::unique_ptr<discards::mojom::SiteDataProvider> site_data_provider_;
   std::string profile_id_;
 
   WEB_UI_CONTROLLER_TYPE_DECL();
diff -Naur a/src/3rdparty/chromium/components/content_settings/core/browser/content_settings_provider.h b/src/3rdparty/chromium/components/content_settings/core/browser/content_settings_provider.h
--- a/src/3rdparty/chromium/components/content_settings/core/browser/content_settings_provider.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/components/content_settings/core/browser/content_settings_provider.h	2021-11-20 03:37:36.802356986 +0000
@@ -23,7 +23,7 @@
 
 class ProviderInterface {
  public:
-  virtual ~ProviderInterface() {}
+  virtual ~ProviderInterface() = default;
 
   // Returns a |RuleIterator| over the content setting rules stored by this
   // provider. If |incognito| is true, the iterator returns only the content
@@ -33,6 +33,9 @@
   // (including |GetRuleIterator|) for the same provider until the
   // |RuleIterator| is destroyed.
   // Returns nullptr to indicate the RuleIterator is empty.
+  //
+  // This method needs to be thread-safe and continue to work after
+  // |ShutdownOnUIThread| has been called.
   virtual std::unique_ptr<RuleIterator> GetRuleIterator(
       ContentSettingsType content_type,
       const ResourceIdentifier& resource_identifier,
diff -Naur a/src/3rdparty/chromium/components/paint_preview/common/subset_font.cc b/src/3rdparty/chromium/components/paint_preview/common/subset_font.cc
--- a/src/3rdparty/chromium/components/paint_preview/common/subset_font.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/components/paint_preview/common/subset_font.cc	2021-11-20 03:42:30.009703768 +0000
@@ -59,6 +59,41 @@
 
 }  // namespace
 
+template <class T, void(*P)(T*)> using resource =
+    std::unique_ptr<T, SkFunctionWrapper<std::remove_pointer_t<decltype(P)>, P>>;
+using HBBlob = resource<hb_blob_t, &hb_blob_destroy>;
+using HBFace = resource<hb_face_t, &hb_face_destroy>;
+using HBSubsetInput = resource<hb_subset_input_t, &hb_subset_input_destroy>;
+using HBSet = resource<hb_set_t, &hb_set_destroy>;
+
+template<typename...> using void_t = void;
+template<typename T, typename = void>
+struct SkPDFHarfBuzzSubset {
+    // This is the HarfBuzz 3.0 interface.
+    // hb_subset_flags_t does not exist in 2.0. It isn't dependent on T, so inline the value of
+    // HB_SUBSET_FLAGS_RETAIN_GIDS until 2.0 is no longer supported.
+    static HBFace Make(T input, hb_face_t* face) {
+        // TODO: When possible, check if a font is 'tricky' with FT_IS_TRICKY.
+        // If it isn't known if a font is 'tricky', retain the hints.
+        hb_subset_input_set_flags(input, 2/*HB_SUBSET_FLAGS_RETAIN_GIDS*/);
+        return HBFace(hb_subset_or_fail(face, input));
+    }
+};
+template<typename T>
+struct SkPDFHarfBuzzSubset<T, void_t<
+    decltype(hb_subset_input_set_retain_gids(std::declval<T>(), std::declval<bool>())),
+    decltype(hb_subset_input_set_drop_hints(std::declval<T>(), std::declval<bool>())),
+    decltype(hb_subset(std::declval<hb_face_t*>(), std::declval<T>()))
+    >>
+{
+    // This is the HarfBuzz 2.0 (non-public) interface, used if it exists.
+    // This code should be removed as soon as all users are migrated to the newer API.
+    static HBFace Make(T input, hb_face_t* face) {
+        hb_subset_input_set_retain_gids(input, true);
+        return HBFace(hb_subset(face, input));
+    }
+};
+
 // Implementation based on SkPDFSubsetFont() using harfbuzz.
 sk_sp<SkData> SubsetFont(SkTypeface* typeface, const GlyphUsage& usage) {
   int ttc_index = 0;
@@ -71,10 +106,12 @@
   hb_set_t* glyphs =
       hb_subset_input_glyph_set(input.get());  // Owned by |input|.
   usage.ForEach(base::BindRepeating(&AddGlyphs, base::Unretained(glyphs)));
-  hb_subset_input_set_retain_gids(input.get(), true);
+  HBFace subset = SkPDFHarfBuzzSubset<hb_subset_input_t*>::Make(input.get(), face.get());
+  if (!subset) {
+    return nullptr;
+  }
 
-  HbScoped<hb_face_t> subset_face(hb_subset(face.get(), input.get()));
-  HbScoped<hb_blob_t> subset_blob(hb_face_reference_blob(subset_face.get()));
+  HbScoped<hb_blob_t> subset_blob(hb_face_reference_blob(subset.get()));
   if (!subset_blob)
     return nullptr;
 
diff -Naur a/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_cache_impl.cc b/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_cache_impl.cc
--- a/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_cache_impl.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_cache_impl.cc	2021-11-20 03:39:28.865600459 +0000
@@ -122,8 +122,8 @@
     return iter->second;
 
   // If not create a new one and add it to the map.
-  internal::SiteDataImpl* site_data =
-      new internal::SiteDataImpl(origin, this, data_store_.get());
+  internal::SiteDataImpl* site_data = new internal::SiteDataImpl(
+      origin, weak_factory_.GetWeakPtr(), data_store_.get());
 
   // internal::SiteDataImpl is a ref-counted object, it's safe to store a raw
   // pointer to it here as this class will get notified when it's about to be
diff -Naur a/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_cache_impl.h b/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_cache_impl.h
--- a/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_cache_impl.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_cache_impl.h	2021-11-20 03:39:28.865600459 +0000
@@ -15,6 +15,7 @@
 #include "base/files/file_path.h"
 #include "base/gtest_prod_util.h"
 #include "base/macros.h"
+#include "base/memory/weak_ptr.h"
 #include "base/scoped_observer.h"
 #include "base/sequence_checker.h"
 #include "components/performance_manager/persistence/site_data/site_data_cache.h"
@@ -100,6 +101,8 @@
 
   SEQUENCE_CHECKER(sequence_checker_);
 
+  base::WeakPtrFactory<SiteDataCacheImpl> weak_factory_{this};
+
   DISALLOW_COPY_AND_ASSIGN(SiteDataCacheImpl);
 };
 
diff -Naur a/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_impl.cc b/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_impl.cc
--- a/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_impl.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_impl.cc	2021-11-20 03:39:28.865600459 +0000
@@ -159,7 +159,7 @@
 }
 
 SiteDataImpl::SiteDataImpl(const url::Origin& origin,
-                           OnDestroyDelegate* delegate,
+                           base::WeakPtr<OnDestroyDelegate> delegate,
                            SiteDataStore* data_store)
     : load_duration_(kSampleWeightFactor),
       cpu_usage_estimate_(kSampleWeightFactor),
@@ -188,13 +188,19 @@
   DCHECK(!IsLoaded());
   DCHECK_EQ(0U, loaded_tabs_in_background_count_);
 
-  DCHECK(delegate_);
-  delegate_->OnSiteDataImplDestroyed(this);
-
-  // TODO(sebmarchand): Some data might be lost here if the read operation has
-  // not completed, add some metrics to measure if this is really an issue.
-  if (is_dirty_ && fully_initialized_)
-    data_store_->WriteSiteDataIntoStore(origin_, FlushStateToProto());
+  // Make sure not to dispatch a notification to a deleted delegate, and gate
+  // the DB write on it too, as the delegate and the data store have the
+  // same lifetime.
+  // TODO(https://crbug.com/1231933): Fix this properly and restore the end of
+  //     life write here.
+  if (delegate_) {
+    delegate_->OnSiteDataImplDestroyed(this);
+
+    // TODO(sebmarchand): Some data might be lost here if the read operation has
+    // not completed, add some metrics to measure if this is really an issue.
+    if (is_dirty_ && fully_initialized_)
+      data_store_->WriteSiteDataIntoStore(origin_, FlushStateToProto());
+  }
 }
 
 base::TimeDelta SiteDataImpl::FeatureObservationDuration(
diff -Naur a/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_impl.h b/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_impl.h
--- a/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_impl.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/components/performance_manager/persistence/site_data/site_data_impl.h	2021-11-20 03:39:28.865600459 +0000
@@ -159,7 +159,7 @@
   friend class performance_manager::MockDataCache;
 
   SiteDataImpl(const url::Origin& origin,
-               OnDestroyDelegate* delegate,
+               base::WeakPtr<OnDestroyDelegate> delegate,
                SiteDataStore* data_store);
 
   virtual ~SiteDataImpl();
@@ -263,7 +263,13 @@
 
   // The delegate that should get notified when this object is about to get
   // destroyed, it should outlive this object.
-  OnDestroyDelegate* const delegate_;
+  // The use of WeakPtr here is a temporary, minimally invasive fix for the UAF
+  // reported in https://crbug.com/1231933. By using a WeakPtr, the call-out
+  // is avoided in the case where the OnDestroyDelegate has been deleted before
+  // all SiteDataImpls have been released.
+  // The proper fix for this is going to be more invasive and less suitable
+  // for merging, should it come to that.
+  base::WeakPtr<OnDestroyDelegate> const delegate_;
 
   // Indicates if this object has been fully initialized, either because the
   // read operation from the database has completed or because it has been
diff -Naur a/src/3rdparty/chromium/components/permissions/permission_request_manager.cc b/src/3rdparty/chromium/components/permissions/permission_request_manager.cc
--- a/src/3rdparty/chromium/components/permissions/permission_request_manager.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/components/permissions/permission_request_manager.cc	2021-11-20 03:36:49.874084070 +0000
@@ -486,12 +486,13 @@
 }
 
 void PermissionRequestManager::ShowBubble() {
-  // There is a race condition where the request might have been removed already
-  // so double-checking that there is a request in progress (crbug.com/1041222).
-  if (!IsRequestInProgress())
+  // There is a race condition where the request might have been removed
+  // already so double-checking that there is a request in progress.
+  //
+  // There is no need to show a new bubble if the previous one still exists.
+  if (!IsRequestInProgress() || view_)
     return;
 
-  DCHECK(!view_);
   DCHECK(web_contents()->IsDocumentOnLoadCompletedInMainFrame());
   DCHECK(current_request_ui_to_use_);
 
diff -Naur a/src/3rdparty/chromium/components/renderer_context_menu/render_view_context_menu_base.cc b/src/3rdparty/chromium/components/renderer_context_menu/render_view_context_menu_base.cc
--- a/src/3rdparty/chromium/components/renderer_context_menu/render_view_context_menu_base.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/components/renderer_context_menu/render_view_context_menu_base.cc	2021-11-20 03:38:56.130118035 +0000
@@ -432,10 +432,13 @@
     ui::PageTransition transition,
     const std::string& extra_headers,
     bool started_from_context_menu) {
+  // Do not send the referrer url to OTR windows. We still need the
+  // |referring_url| to populate the |initiator_origin| below for browser UI.
+  GURL referrer_url;
+  if (disposition != WindowOpenDisposition::OFF_THE_RECORD)
+    referrer_url = referring_url.GetAsReferrer();
   content::Referrer referrer = content::Referrer::SanitizeForRequest(
-      url,
-      content::Referrer(referring_url.GetAsReferrer(),
-                        params_.referrer_policy));
+      url, content::Referrer(referrer_url, params_.referrer_policy));
 
   if (params_.link_url == url &&
       disposition != WindowOpenDisposition::OFF_THE_RECORD)
diff -Naur a/src/3rdparty/chromium/content/browser/background_fetch/background_fetch_job_controller.cc b/src/3rdparty/chromium/content/browser/background_fetch/background_fetch_job_controller.cc
--- a/src/3rdparty/chromium/content/browser/background_fetch/background_fetch_job_controller.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/content/browser/background_fetch/background_fetch_job_controller.cc	2021-11-20 03:38:45.242289807 +0000
@@ -173,6 +173,8 @@
   // TODO(crbug.com/884672): Stop the fetch if the cross origin filter fails.
   BackgroundFetchCrossOriginFilter filter(registration_id_.origin(), *request);
   request->set_can_populate_body(filter.CanPopulateBody());
+  if (!request->can_populate_body())
+    has_failed_cors_request_ = true;
 }
 
 void BackgroundFetchJobController::DidUpdateRequest(const std::string& guid,
@@ -253,7 +255,14 @@
 
 void BackgroundFetchJobController::AbortFromDelegate(
     BackgroundFetchFailureReason failure_reason) {
-  failure_reason_ = failure_reason;
+  if (failure_reason == BackgroundFetchFailureReason::DOWNLOAD_TOTAL_EXCEEDED &&
+      has_failed_cors_request_) {
+    // Don't expose that the download total has been exceeded. Use a less
+    // specific error.
+    failure_reason_ = BackgroundFetchFailureReason::FETCH_ERROR;
+  } else {
+    failure_reason_ = failure_reason;
+  }
 
   Finish(failure_reason_, base::DoNothing());
 }
diff -Naur a/src/3rdparty/chromium/content/browser/background_fetch/background_fetch_job_controller.h b/src/3rdparty/chromium/content/browser/background_fetch/background_fetch_job_controller.h
--- a/src/3rdparty/chromium/content/browser/background_fetch/background_fetch_job_controller.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/content/browser/background_fetch/background_fetch_job_controller.h	2021-11-20 03:38:45.242289807 +0000
@@ -210,6 +210,10 @@
   blink::mojom::BackgroundFetchFailureReason failure_reason_ =
       blink::mojom::BackgroundFetchFailureReason::NONE;
 
+  // Whether one of the requests handled by the controller failed
+  // the CORS checks and should not have its response exposed.
+  bool has_failed_cors_request_ = false;
+
   // Custom callback that runs after the controller is finished.
   FinishedCallback finished_callback_;
 
diff -Naur a/src/3rdparty/chromium/content/browser/background_fetch/storage/get_developer_ids_task.cc b/src/3rdparty/chromium/content/browser/background_fetch/storage/get_developer_ids_task.cc
--- a/src/3rdparty/chromium/content/browser/background_fetch/storage/get_developer_ids_task.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/content/browser/background_fetch/storage/get_developer_ids_task.cc	2021-11-20 03:38:31.033513971 +0000
@@ -9,6 +9,7 @@
 #include "base/bind.h"
 #include "content/browser/background_fetch/storage/database_helpers.h"
 #include "content/browser/service_worker/service_worker_context_wrapper.h"
+#include "content/browser/service_worker/service_worker_registration.h"
 
 namespace content {
 namespace background_fetch {
@@ -26,6 +27,28 @@
 GetDeveloperIdsTask::~GetDeveloperIdsTask() = default;
 
 void GetDeveloperIdsTask::Start() {
+  service_worker_context()->FindReadyRegistrationForIdOnly(
+      service_worker_registration_id_,
+      base::BindOnce(&GetDeveloperIdsTask::DidGetServiceWorkerRegistration,
+                     weak_factory_.GetWeakPtr()));
+}
+
+void GetDeveloperIdsTask::DidGetServiceWorkerRegistration(
+    blink::ServiceWorkerStatusCode status,
+    scoped_refptr<ServiceWorkerRegistration> registration) {
+  if (ToDatabaseStatus(status) != DatabaseStatus::kOk || !registration) {
+    SetStorageErrorAndFinish(
+        BackgroundFetchStorageError::kServiceWorkerStorageError);
+    return;
+  }
+
+  // TODO(crbug.com/1199077): Move this check into the SW context.
+  if (registration->origin() != origin_) {
+    SetStorageErrorAndFinish(
+        BackgroundFetchStorageError::kServiceWorkerStorageError);
+    return;
+  }
+
   service_worker_context()->GetRegistrationUserKeysAndDataByKeyPrefix(
       service_worker_registration_id_, {kActiveRegistrationUniqueIdKeyPrefix},
       base::BindOnce(&GetDeveloperIdsTask::DidGetUniqueIds,
diff -Naur a/src/3rdparty/chromium/content/browser/background_fetch/storage/get_developer_ids_task.h b/src/3rdparty/chromium/content/browser/background_fetch/storage/get_developer_ids_task.h
--- a/src/3rdparty/chromium/content/browser/background_fetch/storage/get_developer_ids_task.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/content/browser/background_fetch/storage/get_developer_ids_task.h	2021-11-20 03:38:31.033513971 +0000
@@ -16,6 +16,9 @@
 #include "url/origin.h"
 
 namespace content {
+
+class ServiceWorkerRegistration;
+
 namespace background_fetch {
 
 // Gets the developer ids for all active registrations - registrations that have
@@ -34,6 +37,9 @@
   void Start() override;
 
  private:
+  void DidGetServiceWorkerRegistration(
+      blink::ServiceWorkerStatusCode status,
+      scoped_refptr<ServiceWorkerRegistration> registration);
   void DidGetUniqueIds(
       blink::ServiceWorkerStatusCode status,
       const base::flat_map<std::string, std::string>& data_map);
diff -Naur a/src/3rdparty/chromium/content/browser/bad_message.h b/src/3rdparty/chromium/content/browser/bad_message.h
--- a/src/3rdparty/chromium/content/browser/bad_message.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/content/browser/bad_message.h	2021-11-20 03:39:05.825965069 +0000
@@ -261,6 +261,7 @@
   RWH_CLOSE_PORTAL = 233,
   MSDH_INVALID_STREAM_TYPE = 234,
   WCI_INVALID_DOWNLOAD_IMAGE_RESULT = 243,
+  RFH_CHILD_FRAME_UNEXPECTED_OWNER_ELEMENT_TYPE = 244,
 
   // Please add new elements here. The naming convention is abbreviated class
   // name (e.g. RenderFrameHost becomes RFH) plus a unique description of the
